package tpv.view;

import tpv.Product;
import tpv.ProductAction;
import tpv.TableManager;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by TheL0w3R on 30/10/2018.
 * All Rights Reserved.
 */
public class MainForm extends JDialog {

    private TableManager tableManager;

    private DefaultTableModel defaultModel;

    private JPanel mainPanel;
    private JTable subtotalTable;
    private JButton appleBtn;
    private JButton pearBtn;
    private JButton strawberryBtn;
    private JButton watermelonBtn;
    private JButton orangeBtn;
    private JButton mangoBtn;
    private JButton papayaBtn;
    private JButton blueberryBtn;
    private JButton bananaBtn;
    private JButton clearBtn;
    private JLabel totalLable;

    public MainForm(Frame owner) {
        super(owner, "TPV", true);
        tableManager = TableManager.getInstance();
        $$$setupUI$$$();
        this.setContentPane(mainPanel);
        this.setSize(900, 650);
        this.setResizable(false);
        this.setLocationRelativeTo(null);

        bindActions();

        this.setVisible(true);
    }

    private void bindActions() {
        clearBtn.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                tableManager.clear();
                updateData();
            }
        });
        appleBtn.addActionListener(new ProductAction(this));
        pearBtn.addActionListener(new ProductAction(this));
        strawberryBtn.addActionListener(new ProductAction(this));
        watermelonBtn.addActionListener(new ProductAction(this));
        orangeBtn.addActionListener(new ProductAction(this));
        mangoBtn.addActionListener(new ProductAction(this));
        papayaBtn.addActionListener(new ProductAction(this));
        blueberryBtn.addActionListener(new ProductAction(this));
        bananaBtn.addActionListener(new ProductAction(this));
    }

    public void updateData() {
        defaultModel.setRowCount(0);
        for (Product p : tableManager.getProducts())
            defaultModel.addRow(p.getRaw());
        defaultModel.fireTableDataChanged();
        totalLable.setText("Total: " + tableManager.getTotal() + "€");
    }

    private void createUIComponents() {
        defaultModel = new DefaultTableModel(new String[][]{}, new String[]{"Producto", "Unidades", "Subtotal"}) {
            @Override
            public boolean isCellEditable(int row, int column) {
                return false;
            }
        };
        subtotalTable = new JTable(defaultModel);
    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$() {
        createUIComponents();
        mainPanel = new JPanel();
        mainPanel.setLayout(new GridBagLayout());
        final JScrollPane scrollPane1 = new JScrollPane();
        GridBagConstraints gbc;
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.gridwidth = 2;
        gbc.gridheight = 2;
        gbc.weightx = 15.0;
        gbc.weighty = 1.0;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.insets = new Insets(15, 15, 5, 5);
        mainPanel.add(scrollPane1, gbc);
        scrollPane1.setViewportView(subtotalTable);
        final JPanel panel1 = new JPanel();
        panel1.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 2;
        gbc.gridy = 0;
        gbc.gridheight = 3;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.insets = new Insets(10, 10, 10, 15);
        mainPanel.add(panel1, gbc);
        final JPanel panel2 = new JPanel();
        panel2.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel2, gbc);
        appleBtn = new JButton();
        appleBtn.setHorizontalTextPosition(0);
        appleBtn.setIcon(new ImageIcon(getClass().getResource("/res/apple.png")));
        appleBtn.setText("Manzana - 0.50€");
        appleBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel2.add(appleBtn, gbc);
        final JPanel panel3 = new JPanel();
        panel3.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel3, gbc);
        pearBtn = new JButton();
        pearBtn.setHorizontalTextPosition(0);
        pearBtn.setIcon(new ImageIcon(getClass().getResource("/res/pear.png")));
        pearBtn.setText("Pera - 0.45€");
        pearBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel3.add(pearBtn, gbc);
        final JPanel panel4 = new JPanel();
        panel4.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 2;
        gbc.gridy = 0;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel4, gbc);
        bananaBtn = new JButton();
        bananaBtn.setHorizontalTextPosition(0);
        bananaBtn.setIcon(new ImageIcon(getClass().getResource("/res/banana.png")));
        bananaBtn.setText("Plátano - 0.30€");
        bananaBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel4.add(bananaBtn, gbc);
        final JPanel panel5 = new JPanel();
        panel5.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 2;
        gbc.gridy = 1;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel5, gbc);
        strawberryBtn = new JButton();
        strawberryBtn.setHorizontalTextPosition(0);
        strawberryBtn.setIcon(new ImageIcon(getClass().getResource("/res/strawberry.png")));
        strawberryBtn.setText("Fresa - 0.15€");
        strawberryBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel5.add(strawberryBtn, gbc);
        final JPanel panel6 = new JPanel();
        panel6.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel6, gbc);
        watermelonBtn = new JButton();
        watermelonBtn.setHorizontalTextPosition(0);
        watermelonBtn.setIcon(new ImageIcon(getClass().getResource("/res/watermelon.png")));
        watermelonBtn.setText("Sandía - 5.16€");
        watermelonBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel6.add(watermelonBtn, gbc);
        final JPanel panel7 = new JPanel();
        panel7.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel7, gbc);
        orangeBtn = new JButton();
        orangeBtn.setHorizontalTextPosition(0);
        orangeBtn.setIcon(new ImageIcon(getClass().getResource("/res/orange.png")));
        orangeBtn.setText("Naranja - 0.64€");
        orangeBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel7.add(orangeBtn, gbc);
        final JPanel panel8 = new JPanel();
        panel8.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel8, gbc);
        mangoBtn = new JButton();
        mangoBtn.setHorizontalTextPosition(0);
        mangoBtn.setIcon(new ImageIcon(getClass().getResource("/res/mango.png")));
        mangoBtn.setText("Mango - 0.70€");
        mangoBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel8.add(mangoBtn, gbc);
        final JPanel panel9 = new JPanel();
        panel9.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        gbc.gridy = 2;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel9, gbc);
        papayaBtn = new JButton();
        papayaBtn.setHorizontalTextPosition(0);
        papayaBtn.setIcon(new ImageIcon(getClass().getResource("/res/papaya.png")));
        papayaBtn.setText("Papaya - 7.30€");
        papayaBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel9.add(papayaBtn, gbc);
        final JPanel panel10 = new JPanel();
        panel10.setLayout(new GridBagLayout());
        gbc = new GridBagConstraints();
        gbc.gridx = 2;
        gbc.gridy = 2;
        gbc.weightx = 0.25;
        gbc.weighty = 0.25;
        gbc.fill = GridBagConstraints.VERTICAL;
        panel1.add(panel10, gbc);
        blueberryBtn = new JButton();
        blueberryBtn.setHorizontalTextPosition(0);
        blueberryBtn.setIcon(new ImageIcon(getClass().getResource("/res/blueberry.png")));
        blueberryBtn.setText("Arándanos - 0.08€");
        blueberryBtn.setVerticalTextPosition(3);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        panel10.add(blueberryBtn, gbc);
        totalLable = new JLabel();
        totalLable.setHorizontalAlignment(0);
        totalLable.setHorizontalTextPosition(10);
        totalLable.setText("Total: ");
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.weightx = 0.4;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.insets = new Insets(5, 5, 15, 5);
        mainPanel.add(totalLable, gbc);
        clearBtn = new JButton();
        clearBtn.setText("Reiniciar");
        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        gbc.gridy = 2;
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.insets = new Insets(5, 5, 15, 5);
        mainPanel.add(clearBtn, gbc);
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$() {
        return mainPanel;
    }
}
